@
@ asm.s
@ -----
@
@ get_timer()
@
@ Hook for DEV task (1) that catches our timer message
@ and sends message to UI task (5)
@
@ Hook for UI task (5) that catches our UI message
@ and handles timers
@

@ ************************************************************* GET_TIMER()

.global get_timer

get_timer:

ldr  r2,io
loop:
ldrh r0,[r2,#16]
ldrh r1,[r2,#16]
cmp  r0,r1
bne  loop

mov  pc,lr

@ ************************************************************* TASK 1 HOOK

.global hook_task1

hook_task1:

push {lr}

ht1_loop:
bl   get_task_message
mov  r1,#2
lsl  r1,r1,#8
cmp  r0,r1
bne  ht1_end

@adr  r0,debug_text
@ldr  r1,_list
@ldr  r1,[r1]
@ldr  r1,[r1,#4]
@bl   printf

ldr  r0,task5msg_send
ldr  r1,_list
ldr  r1,[r1]		@ we're sending timer address to UI task
cmp  r1,#0
beq  ht1_loop
ldr  r2,[r1,#4]
bl   send_ui_message
b    ht1_loop

ht1_end:
pop  {pc}

@ ************************************************************* TASK 5 HOOK

.global hook_task5

hook_task5:

push {lr}

ldr  r1,task5msg
cmp  r0,r1
bne  exit

ldr  r1,_message
ldr  r0,[r1,#8]
ldr  r1,[r1,#12]
bl   handle_timer
mov  r0,#0xdc

exit:

.global hook_task5_code
hook_task5_code:
nop
nop

pop  {pc}

@ ************************************************************* START_SYS_TIMER

.global start_sys_timer

start_sys_timer:

push {lr}

ldr  r0,_own_sys_timer
mov  r2,r1
mov  r1,#1              @ TT_TASK_MESSAGE
bl   own_timer_start

pop  {pc}

@ ************************************************************* ABORT_SYS_TIMER

.global abort_sys_timer

abort_sys_timer:

push {lr}

ldr  r0,_own_sys_timer
bl   own_timer_abort

pop  {pc}

@ *************************************************************

.align

task5msg_send:
.long 0x9bfb

task5msg:
.long 0x1bfb

io:
.long 0x20000

_list:
.long list

_message:
.long message

_own_sys_timer:
.long own_sys_timer

@debug_text:
@.asciz "Timer reached zero; sending handling of todo=0x%lX\n"
